package com.engine.salary.mapper.salarybill;

import com.engine.salary.entity.salaryBill.po.SalaryBillItemNamePO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

/**
 * @author Harryxzy
 * @ClassName SalaryBillItemNameMapper
 * @date 2023/07/18 15:58
 * @description 工资单薪资项目展示名
 */
public interface SalaryBillItemNameMapper {
    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    List<SalaryBillItemNamePO> listAll();

    /**
     * 条件查询
     *
     * @return 返回集合，没有返回空List
     */
    List<SalaryBillItemNamePO> listSome(SalaryBillItemNamePO salaryBillItemNamePO);


    /**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
    SalaryBillItemNamePO getById(Long id);

    /**
     * 新增，忽略null字段
     *
     * @param salaryBillItemNamePO 新增的记录
     * @return 返回影响行数
     */
    int insertIgnoreNull(SalaryBillItemNamePO salaryBillItemNamePO);

    /**
     * 修改，修改所有字段
     *
     * @param salaryBillItemNamePO 修改的记录
     * @return 返回影响行数
     */
    int update(SalaryBillItemNamePO salaryBillItemNamePO);

    /**
     * 修改，忽略null字段
     *
     * @param salaryBillItemNamePO 修改的记录
     * @return 返回影响行数
     */
    int updateIgnoreNull(SalaryBillItemNamePO salaryBillItemNamePO);

    /**
     * 删除记录
     *
     * @param id 待删除的记录id
     * @return 返回影响行数
     */
    int delete(Long id);

    /**
     * 批量更新
     * @param salaryBillItemNamePO
     */
    void batchUpdate(@Param("collection") List<SalaryBillItemNamePO> salaryBillItemNamePO);

    /**
     * 批量插入
     * @param salaryBillItemNamePO
     */
    void batchInsert(@Param("collection") List<SalaryBillItemNamePO> salaryBillItemNamePO);

    /**
     * 根据薪资项目、模板id、模板类型批量删除
     * @param salaryItemIds
     * @param salaryTemplateId
     * @param salaryBillType
     */
    void deleteByItemIdsAndTemplateId(@Param("salaryItemIds") List<Long> salaryItemIds, @Param("salaryTemplateId") Long salaryTemplateId, @Param("salaryBillType") Integer salaryBillType);

    /**
     * 根据idList删除
     * @param ids
     */
    void deleteByIds(@Param("collection") List<Long> ids);

    /**
     * 根据模板id删除
     * @param ids
     */
    void deleteByTemplateIds(@Param("collection") Collection<Long> ids);
}
